﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: Ouroboros
 * Dátum: 2010.11.01.
 * Idő: 13:38
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Collections.Generic;
//
using TetheredSun.Mathematics;

namespace TetheredSun.SignalAnalysis
{
	/// <summary>
	/// Description of SineFitFunction.
	/// </summary>
	public class SineFitFunction : IFitFunction
	{
		protected double[] parameters;
		
		public SineFitFunction(IList<Sine> sines)
		{
			int j;
			
			parameters = new double[sines.Count * 3];
			
			for (int i = 0; i < sines.Count; i++) {
				j = i * 3;
				parameters[j] = sines[i].Amplitude;
				parameters[j + 1] = sines[i].Frequency;
				parameters[j + 2] = sines[i].Phase;
			}
		}
		
		public double[] Parameters {
			get { return parameters; }
			set { parameters = value; }
		}
		
		public double[][] GetJacobian(double[] x, double[] y)
		{
			throw new NotImplementedException();
		}
		
		protected double[] GetJacobianRow(double[] x, double[] y, int rowIndex)
		{
			throw new NotImplementedException();
		}
		
		public double[] GetResiduals(double[] x, double[] y)
		{
			double[] residuals = new double[x.Length];
			double[] fx = GetValues(x);
			
			for (int i = 0; i < fx.Length; i++) {
				residuals[i] = y[i] - fx[i];
			}
			
			return residuals;
		}
		
		public double GetValue(double x)
		{
			double a;
			double f;
			double p;
			double value = 0.0;
			int j;
			
			for (int i = 0; i < parameters.Length / 3; i++) {
				j = 3 * i;
				a = parameters[j];
				f = parameters[j + 1];
				p = parameters[j + 2];
				value += a * Math.Sin(2.0 * Math.PI * f * x + p);
			}
			
			return value;
		}
		
		public double[] GetValues(double[] x)
		{
			double a;
			double f;
			double p;
			double xk;
			double[] y = new double[x.Length];
			int j;
			
			for (int i = 0; i < parameters.Length / 3; i++) {
				j = 3 * i;
				a = parameters[j];
				f = parameters[j + 1];
				p = parameters[j + 2];
				for (int k = 0; k < x.Length; k++) {
					xk = x[k];
					y[k] += a * Math.Sin(2.0 * Math.PI * f * xk + p);
				}
			}
			
			return y;
		}
		
	}
}
